import React from "react";
import { Context, Select } from "./Context";
export declare type ConsumerProps<State, T = any> = {
    select: Select<State, T>;
    children: (selected: T) => React.ReactNode;
};
export declare function createConsumer<State>(Consumer: React.Consumer<State>, context: Context<State>): {
    new <T>(props: ConsumerProps<State, any>): {
        /**
         * rednder.
         */
        render(): JSX.Element;
        /**
         * select and versioning.
         */
        select: (state: State) => JSX.Element;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<ConsumerProps<State, T>>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callBack?: (() => void) | undefined): void;
        readonly props: Readonly<{
            children?: React.ReactNode;
        }> & Readonly<ConsumerProps<State, T>>;
        state: Readonly<{}>;
        context: any;
        refs: {
            [key: string]: React.ReactInstance;
        };
    };
};
